<?
//ITDB:IT-items database
//sivann at gmail.com 2008-2009
//init.php: init db + some variables

//$scriptdir=dirname($_SERVER['SCRIPT_FILENAME']);
$scriptdir=getcwd(); 

date_default_timezone_set("GMT");
$servername=$_SERVER['SERVER_NAME'];
$scriptname=$_SERVER['SCRIPT_NAME'];

//for scripts including init.php from inside php/ directory:
if (basename($scriptdir)=="php") { 
  $scriptdir=preg_replace("/\/php$/","",$scriptdir);
}

//wscriptdir: www relative address of base itdb directory (/itdb)
$wscriptdir=dirname($_SERVER['SCRIPT_NAME']);
if (basename($wscriptdir)=="php") { 
  $wscriptdir=preg_replace("/\/php$/","",$wscriptdir);
}


if (isset($_SERVER['HTTP_X_FORWARDED_FOR']))
  $remaddr=$_SERVER['HTTP_X_FORWARDED_FOR'];
else 
  $remaddr=$_SERVER['REMOTE_ADDR'];


require_once('conf.php');

if (isset($_SERVER['HTTPS']) && ($_SERVER['HTTPS'] == "on"))
  $prot="https" ;
else
  $prot="http";

$fscriptname="$prot://$servername$scriptname";
$fuploaddirwww="$prot://$servername".dirname($scriptname)."/$uploaddirwww";

//echo dirname($scriptname);
$procuserinfo = posix_getpwuid(posix_getgid()); $procusername=$procuserinfo['name'];

/**********************************************/

if ($dateformat=="dmy") {
  $datetitle="d/m/y or yyyy";
  $datecalparam="dd/MM/yyyy";
  $dateparam="d/m/Y";
}
else {
  $datetitle="m/d/y or yyyy";
  $datecalparam="MM/dd/yyyy";
  $dateparam="m/d/Y";
}

//to work without register_globals
foreach($_REQUEST as $k => $v) { ${$k} = $v; }


if (!file_exists($dbfile)) {
  echo "$dbfile not found<br>";
  echo "<b><big>if this is a fresh install, copy pure.db to $dbfile</b></big><br>";
  echo "in unix: cp pure.db itdb.db";
  exit;
}

if (!is_writable($dbfile)) {
  echo "$dbfile is not writeable by apache<br>";
  echo "<b><big>make $dbfile writeable by the user running the web server</big></b><br>";
  echo "in unix: chown $procusername itdb.db; chmod u+w itdb.db";
  exit;
}

if (!is_writable($scriptdir)) {
  echo "$scriptdir is not writeable by apache<br>";
  echo "<b><big>make $scriptdir writeable by the user running the web server</big></b><br>";
  echo "in unix: chown $procusername itdb/; chmod u+w itdb/";
  exit;
}


//open db
try {
  $dbh = new PDO("sqlite:$dbfile");
} 
catch (PDOException $e) {
  print "Open database Error!: " . $e->getMessage() . "<br>";
  die();
}
$error = $dbh->errorInfo();
if($error[0] && isset($error[2]))  echo "Error 00: ".$error[2]."<br>";


//some configuration
$ret = $dbh->exec("PRAGMA case_sensitive_like = 0;");
$ret = $dbh->exec("PRAGMA encoding = \"UTF-8\";");


$uploadErrors = array(
    UPLOAD_ERR_OK => 'There is no error, the file uploaded with success.',
    UPLOAD_ERR_INI_SIZE => 'The uploaded file exceeds the upload_max_filesize directive in php.ini.',
    UPLOAD_ERR_FORM_SIZE => 'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form.',
    UPLOAD_ERR_PARTIAL => 'The uploaded file was only partially uploaded.',
    UPLOAD_ERR_NO_FILE => 'No file was uploaded.',
    UPLOAD_ERR_NO_TMP_DIR => 'Missing a temporary folder.',
    UPLOAD_ERR_CANT_WRITE => 'Failed to write file to disk.',
    UPLOAD_ERR_EXTENSION => 'File upload stopped by extension.',
);

//convert Y/M/D dates to unix timestamp
function ymd2sec($d)
{
  global $dateformat;

  if (!strlen($d))
    $purchasedate2="NULL";
  elseif ($dateformat=="dmy"){
    $x=explode("/",$d);
    if ((count($x)==1) && strlen(trim($d))==4) { //only year
      $d2=  mktime(0, 0, 0, 1, 1, $d);
    }
    else {
      $d2=  mktime(0, 0, 0, $x[1], $x[0], $x[2]);
    }
//echo "$d -> $d2<br>";
    return $d2;
  }
  elseif ($dateformat=="mdy"){
    $x=explode("/",$d);
    if ((count($x)==1) && strlen(trim($d))==4) { //only year
      $d2=  mktime(0, 0, 0, 1, 1, $d);
    }
    else {
      $d2=  mktime(0, 0, 0, $x[0], $x[1], $x[2]);
    }
    return $d2;
  }
  return "";
}

//remove invalid filename characters
function validfn($s) {
  $f =preg_split('//u', 'ΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΣΤΥΦΧΨΩΪΫΌΎΏΆΈΰαβγδεζηθικλμνξοπρςστυφχψωίϊΐϋόύώάέΰ');
  $t =preg_split('//u', 'ABGDEZHUIKLMNJOPRSSTYFXCVIUOUVAEUabgdezhuiklmnjoprsstyfxcviiiuouvaeu');
  $s=str_replace($f,$t,$s);
  $reserved = preg_quote('\/:*?"<>|', '/');
  $s=preg_replace("/([-\\x00-\\x20\\x7f-\\xff{$reserved}])/e", "", $s); 
  $s=strtolower($s);
  return $s;
}


//encode string for sql/html
function strenc($s)
{
  $s=htmlspecialchars($s,ENT_QUOTES,"UTF-8");
  return $s;
}

if (get_magic_quotes_gpc()) {
    function stripslashes_deep($value)
    {
        $value = is_array($value) ?
                    array_map('stripslashes_deep', $value) :
                    stripslashes($value);

        return $value;
    }

    $_POST = array_map('stripslashes_deep', $_POST);
    $_GET = array_map('stripslashes_deep', $_GET);
    $_COOKIE = array_map('stripslashes_deep', $_COOKIE);
    $_REQUEST = array_map('stripslashes_deep', $_REQUEST);
}

//////////////////// Database functions /////
// check permissions, log errors and transactions
// 
//encode string for sql/html

//for insert, update, delete
function db_exec($dbh,$sql,$skipauth=0,$skiphist=0,&$wantlastid=0)
{
global $authstatus,$userdata, $remaddr;

  if (!$skipauth && !$authstatus) {echo "<big><b>Not logged in</b></big><br>";return 0;}
  if (stristr($sql,"insert ")) $skiphist=1; //for lastid function to work.

  //find user access
  $usr=$userdata[0]['username'];
  $sqlt="SELECT usertype FROM users where username='$usr'";
  $sth=$dbh->prepare($sqlt);
  $sth->execute();
  $ut=$sth->fetch(PDO::FETCH_ASSOC);
  $usertype=($ut['usertype']);

  if (!$skipauth && $usertype && (stristr($sql,"DELETE") || stristr($sql,"UPDATE") || stristr($sql,"INSERT"))) {
    echo "<big><b>Access Denied, user '$usr' is read-only</b></big><br>";
    return 0;
  }

  $r=$dbh->exec($sql);
  $error = $dbh->errorInfo();
  if($error[0] && isset($error[2])) {
    echo "<br><b>DB Error: ($sql): ".$error[2]."<br></b>";
    $backtrace = debug_backtrace();
    print_r($backtrace);
    return 0;
  }
  $wantlastid=$dbh->lastInsertId();

  if (!$skiphist) {
    $hist="";
    $t=time();
    $escsql=str_replace("'","''",$sql);
    $histsql="INSERT into history (date,sql,ip,authuser) VALUES ($t,'$escsql','$remaddr','".$_COOKIE["itdbuser"]."')";
    //update history table
    $rh=$dbh->exec($histsql);
    $error = $dbh->errorInfo();
    if($error[0] && isset($error[2])) {
      echo "<br><b>HIST DB Error: ($histsql): ".$error[2]."<br></b>";
      $backtrace = debug_backtrace();
      print_r($backtrace);
      return 0;
    }
  }
  return $r;
}

//for select
function db_execute($dbh,$sql,$skipauth=0)
{
  global $authstatus;
  if (!$skipauth && !$authstatus) {echo "<big><b>Not logged in</b></big><br>";return 0;}
  $sth = $dbh->prepare($sql);
  $error = $dbh->errorInfo();
  if($error[0] && isset($error[2])) {
    echo "<br><b>DB Error: ($sql): ".$error[2]."<br></b>";
    $backtrace = debug_backtrace();
    print_r($backtrace);
    return 0;
  }
  $sth->execute();
  return $sth;
}


///////////cookies///////////

$authstatus=0;
$authmsg="Not logged in";

if (isset($_POST['logout'])) {
   setcookie("itdbcookie1",'', time()+3600*1,$wscriptdir);
   header("Location: $scriptname"); //eat get parameters
}
elseif (isset($_POST['authusername'])){ //logging in
 $username=$_POST['authusername'];
 $password=$_POST['authpassword'];
 $sth=db_execute($dbh,"SELECT * from users where username='$username' limit 1",1);
 $userdata=$sth->fetchAll(PDO::FETCH_ASSOC);
 $nr=count($userdata);
 if ((!$nr) || $userdata[0]['username']!=$username) {
    $authstatus=0;
    $authmsg="Invalid username.";
 }
 elseif (($userdata[0]['pass']==$password) && strlen($password)) { //correct password
   $rnd=mt_rand(); //create a random
   //store random in db
   db_exec($dbh,"UPDATE users set cookie1='$rnd' where username='$username'",1,1);
   //store random in browser
   setcookie("itdbcookie1",$rnd, time()+3600*24*2,$wscriptdir); //random number set for two days
   setcookie("itdbuser",$username, time()+3600*24*60,$wscriptdir); //username
   $authstatus=1;
   $authmsg="User Authenticated";
 }
 else { //wrong password
   $authstatus=0;
   $authmsg="Wrong Password";
 }

} //logging in 
elseif (isset($_COOKIE["itdbuser"]) && ! isset($_COOKIE["itdbcookie1"])) {
  $authstatus=0;
  $authmsg="Session Expired";
} 
elseif (isset($_COOKIE["itdbuser"])) { //& isset itdbookie1, check if valid
  $sql="SELECT * from users where username='".$_COOKIE["itdbuser"]."' limit 1";
  $sth=db_execute($dbh,$sql,1);
  $userdata=$sth->fetchAll(PDO::FETCH_ASSOC);
  //$dbg= "db cookie:".$userdata[0]['cookie1'] . "<br>browser cookie:".$_COOKIE["itdbcookie1"];

  if ($userdata[0]['cookie1']==$_COOKIE["itdbcookie1"]) {
    $authstatus=1;
    $authmsg="Welcome back ".$_COOKIE["itdbuser"];
    setcookie("itdbcookie1",$userdata[0]['cookie1'], time()+3600*24*2,$wscriptdir); //renew for two days
  }
  else {
    $authstatus=0;
    $authmsg="Logged on from another browser? Please re-login.";
  }
}
else
  $authmsg="Please Login!";

/********************************* SQL FUNCTIONS ****************************************/

function ftype2str($typeid,$dbh) {

  $sql="SELECT typedesc from filetypes WHERE ".
        " id='$typeid'";
  $sth=db_execute($dbh,$sql);
  $typestr=$sth->fetch(PDO::FETCH_ASSOC);
  $typestr=$typestr['typedesc'];
  return ucfirst($typestr);

}
//returns files array from invoice id
function invid2files($invid,$dbh) {
  $sql="SELECT files.* from files,invoice2file WHERE ".
        " invoice2file.invoiceid='$invid' AND ".
        " invoice2file.fileid=files.id";
  $sth=db_execute($dbh,$sql);
  $fn=$sth->fetchAll(PDO::FETCH_ASSOC);
  return $fn;
}

//returns files array from software id
function softid2files($softid,$dbh) {
  $sql="SELECT files.* from files,software2file WHERE ".
        " software2file.softwareid='$softid' AND ".
        " software2file.fileid=files.id";
  $sth=db_execute($dbh,$sql);
  $fn=$sth->fetchAll(PDO::FETCH_ASSOC);
  return $fn;
}

//returns files array from software id
function itemid2files($itemid,$dbh) {
  $sql="SELECT files.* from files,item2file WHERE ".
        " item2file.itemid='$itemid' AND ".
        " item2file.fileid=files.id";
  $sth=db_execute($dbh,$sql);
  $fn=$sth->fetchAll(PDO::FETCH_ASSOC);
  return $fn;
}



//returns number of connected items/software/invoices with a fileid
function countfileidlinks($fileid,$dbh) {
$count=0;
  $sql="select count(softwareid) count from software2file where fileid=$fileid";
  $sth=db_execute($dbh,$sql);
  $r=$sth->fetch(PDO::FETCH_ASSOC);
  $count+=$r['count'];

  $sql="select count(*) count from invoice2file where fileid=$fileid";
  $sth=db_execute($dbh,$sql);
  $r=$sth->fetch(PDO::FETCH_ASSOC);
  $count+=$r['count'];

  $sql="select count(*) count from item2file where fileid=$fileid";
  $sth=db_execute($dbh,$sql);
  $r=$sth->fetch(PDO::FETCH_ASSOC);
  $count+=$r['count'];

  return $count;
}

function delfile($fileid,$dbh) {
global $uploaddir;
  //delete inter-item links
  $sql="select fname from files where id=$fileid";
  $sth=db_execute($dbh,$sql);
  $r=$sth->fetch(PDO::FETCH_ASSOC);
  $fname=$r['fname'];


  $sql="DELETE from files where id=$fileid";
  $sth=db_exec($dbh,$sql);

  $sql="DELETE from invoice2file where fileid=$fileid";
  $sth=db_exec($dbh,$sql);

  $sql="DELETE from software2file where fileid=$fileid";
  $sth=db_exec($dbh,$sql);

  $sql="DELETE from item2file where fileid=$fileid";
  $sth=db_exec($dbh,$sql);

  if (strlen($fname))
    unlink($uploaddir.$fname);
}

?>
